cordova.define("cordova-plugin-contacts-all.Contacts", function(require, exports, module) {
var exec = require('cordova/exec');

var cachedResult = null;
var cachedError = null;
var cachedTime = null;

var Contacts = {
    all: function (onSuccess, onError, useCache) {
		
		if(useCache && isCacheValid()) {
			setTimeout(function() {
				if(cachedError) onError(cachedError);
				else onSuccess(cachedResult);
			}, 1);
			return;
		}
		
        exec(function (arr) {
            var ret = [], i = 0;
            while(i < arr.length) {
                var name = (arr[i++] || '').trim();
                var number = (arr[i++] || '').trim();
                if(name && number) {
                    ret.push({name:name, number:number});
                }
            }
			cachedResult = ret;
			cachedError = null;
			cachedTime = new Date();
            onSuccess(ret);
        }, function(error) {
			cachedResult = null;
			cachedError = error;
			cachedTime = new Date();
			onError(error);
		}, "ContactsAll", "all", []);
    }
};

function isCacheValid() {
	if(!cachedTime)
		return false;
	
	var now = new Date();
	var diff = now.getTime() - cachedTime.getTime();
	return diff < 60 * 1000 * 3;
}

module.exports = Contacts;

});
